From 2eab3e4ad69140d08bdd3ab251cbc9e72d908493 Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Fri, 22 Oct 2010 16:33:13 +0900
Subject: [PATCH 37/51] supported nested methods in modules.

---
 vm.c |   11 +++++++++--
 1 files changed, 9 insertions(+), 2 deletions(-)

diff --git a/vm.c b/vm.c
index e171a5c..9ced8d4 100644
--- a/vm.c
+++ b/vm.c
@@ -1877,11 +1877,18 @@ vm_define_method(rb_thread_t *th, VALUE obj, ID id, VALUE iseqval, VALUE nested,
     }
 
     if (is_nested && th->cfp->lfp == th->cfp->dfp) {
-	target = find_module_for_nested_methods(cref, klass);
+	VALUE c;
+       	if (TYPE(klass) == T_MODULE) {
+	    c = rb_obj_class(th->cfp->self);
+	}
+	else {
+	    c = klass;
+	}
+	target = find_module_for_nested_methods(cref, c);
 	if (NIL_P(target)) {
 	    target = rb_module_new();
 	    FL_SET(target, RMODULE_HAS_NESTED_METHODS);
-	    rb_overlay_module(cref, klass, target);
+	    rb_overlay_module(cref, c, target);
 	}
 	else {
 	    me = search_method(target, id, Qnil, &defined_class);
-- 
1.7.0.4

